=== modified file 'plugin/info_schema/tables.cc'
--- plugin/info_schema/tables.cc	2010-01-03 23:56:16 +0000
+++ plugin/info_schema/tables.cc	2010-01-05 01:41:25 +0000
@@ -379,9 +379,9 @@
 
     if (tmp_table != NULL)
     {
-      const std::string plugin_name= tmp_table->getPluginName();
+      const std::string &plugin_name= tmp_table->getPluginName();
 
-      if (plugin_name != "")
+      if (! plugin_name.empty())
       {
         table->field[21]->set_notnull();
         table->field[21]->store(plugin_name.c_str(), plugin_name.size(), cs);

=== modified file 'tests/r/information_schema.result'
--- tests/r/information_schema.result	2010-01-03 23:56:16 +0000
+++ tests/r/information_schema.result	2010-01-05 01:41:25 +0000
@@ -122,7 +122,7 @@
 SELECT table_schema, count(*) FROM information_schema.TABLES
 WHERE table_name NOT LIKE 'ndb_%' AND 
 table_name NOT LIKE 'falcon%' AND
-table_name NOT LIKE 'MEMCACHED%'
+plugin_name IS NULL
 GROUP BY TABLE_SCHEMA;
 table_schema	count(*)
 information_schema	24
@@ -247,7 +247,7 @@
 c2.column_name LIKE '%SCHEMA%'
         )
 AND t.table_name NOT LIKE 'falcon%'
-  AND t.table_name NOT LIKE 'MEMCACHED%';
+  AND t.plugin_name IS NULL;
 table_name	column_name
 CHARACTER_SETS	CHARACTER_SET_NAME
 COLLATIONS	COLLATION_NAME
@@ -288,7 +288,7 @@
 c2.column_name LIKE '%SCHEMA%'
         )
 AND t.table_name NOT LIKE 'falcon%'
-  AND t.table_name NOT LIKE 'MEMCACHED%';
+  AND t.plugin_name IS NULL;
 table_name	column_name
 CHARACTER_SETS	CHARACTER_SET_NAME
 COLLATIONS	COLLATION_NAME
@@ -344,7 +344,7 @@
 on t.table_schema = c1.table_schema AND t.table_name = c1.table_name
 where t.table_schema = 'information_schema' AND
 t.table_name not like 'falcon%' AND
-t.table_name not like 'MEMCACHED%' AND
+t.plugin_name IS NULL AND
 c1.ordinal_position =
 (select isnull(c2.column_type) -
 isnull(group_concat(c2.table_schema, '.', c2.table_name)) +
@@ -536,7 +536,9 @@
 utf8_unicode_ci	utf8
 SELECT table_name, column_name
 FROM information_schema.columns
-WHERE table_name NOT LIKE 'MEMCACHED%'
+WHERE table_name IN
+(SELECT table_name FROM information_schema.tables 
+WHERE plugin_name IS NULL)
 ORDER BY table_name;
 table_name	column_name
 CHARACTER_SETS	CHARACTER_SET_NAME
@@ -1053,7 +1055,7 @@
 CONSTRAINT_CATALOG	CONSTRAINT_SCHEMA	CONSTRAINT_NAME	TABLE_SCHEMA	TABLE_NAME	CONSTRAINT_TYPE
 SELECT table_schema, table_name
 FROM information_schema.tables
-WHERE table_name NOT LIKE 'MEMCACHED%'
+WHERE plugin_name IS NULL
 ORDER BY table_name;
 table_schema	table_name
 information_schema	CHARACTER_SETS

=== modified file 'tests/t/information_schema.test'
--- tests/t/information_schema.test	2009-11-29 06:12:52 +0000
+++ tests/t/information_schema.test	2010-01-05 01:41:25 +0000
@@ -127,7 +127,7 @@
 SELECT table_schema, count(*) FROM information_schema.TABLES
 WHERE table_name NOT LIKE 'ndb_%' AND 
 table_name NOT LIKE 'falcon%' AND
-table_name NOT LIKE 'MEMCACHED%'
+plugin_name IS NULL
 GROUP BY TABLE_SCHEMA;
 
 #
@@ -259,7 +259,7 @@
                   c2.column_name LIKE '%SCHEMA%'
         )
   AND t.table_name NOT LIKE 'falcon%'
-  AND t.table_name NOT LIKE 'MEMCACHED%';
+  AND t.plugin_name IS NULL;
 SELECT t.table_name, c1.column_name
   FROM information_schema.tables t
        INNER JOIN
@@ -275,7 +275,7 @@
                   c2.column_name LIKE '%SCHEMA%'
         )
   AND t.table_name NOT LIKE 'falcon%'
-  AND t.table_name NOT LIKE 'MEMCACHED%';
+  AND t.plugin_name IS NULL;
 
 #
 # Bug#21231: query with a simple non-correlated subquery over
@@ -313,7 +313,7 @@
 on t.table_schema = c1.table_schema AND t.table_name = c1.table_name
 where t.table_schema = 'information_schema' AND
       t.table_name not like 'falcon%' AND
-      t.table_name not like 'MEMCACHED%' AND
+      t.plugin_name IS NULL AND
         c1.ordinal_position =
         (select isnull(c2.column_type) -
          isnull(group_concat(c2.table_schema, '.', c2.table_name)) +
@@ -437,7 +437,9 @@
 #
 SELECT table_name, column_name
 FROM information_schema.columns
-WHERE table_name NOT LIKE 'MEMCACHED%'
+WHERE table_name IN
+(SELECT table_name FROM information_schema.tables 
+ WHERE plugin_name IS NULL)
 ORDER BY table_name;
 
 #
@@ -500,7 +502,7 @@
 #
 SELECT table_schema, table_name
 FROM information_schema.tables
-WHERE table_name NOT LIKE 'MEMCACHED%'
+WHERE plugin_name IS NULL
 ORDER BY table_name;
 
 # 

